"use strict";
/* eslint-disable require-jsdoc */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ExpressTS = /** @class */ (function () {
    function ExpressTS() {
    }
    ExpressTS.validateType = function (type) {
        switch (type) {
            case 'functionParams':
                return type;
            case 'injections':
                return type;
            case 'responders':
                return type;
            case 'entities':
                return type;
            case 'domains':
                return type;
            case 'actions':
                return type;
            default:
                throw new Error('Invalid Data Type!');
        }
    };
    ExpressTS.inject = function (target, source, type) {
        target.prototype = source.prototype;
        target[this.symbols.name] = source.name;
        target[this.symbols.type] = type;
    };
    ExpressTS.getInjectedField = function (target, field) {
        return target[this.symbols[field.toString()]];
    };
    ExpressTS.clearInjections = function () {
        this.injections = {};
    };
    ExpressTS.setData = function (name, value, type) {
        var _a;
        if (!name || !type) {
            return null;
        }
        var validType = this.validateType(type);
        this[validType.toString()] = __assign(__assign({}, this[validType.toString()]), (_a = {}, _a[name] = value, _a));
    };
    ExpressTS.getData = function (name, type) {
        if (!name || !type) {
            return null;
        }
        var validType = this.validateType(type);
        if (!this[validType.toString()][name.toString()]) {
            return null;
        }
        if (Array.isArray(this[validType.toString()][name.toString()])) {
            return __spreadArrays(this[validType.toString()][name.toString()]);
        }
        switch (typeof this[validType.toString()][name.toString()]) {
            case 'string':
                return "" + this[validType.toString()][name.toString()];
            case 'object':
                return Object.assign({}, this[validType.toString()][name.toString()]);
            default:
                return this[validType.toString()][name.toString()];
        }
    };
    ExpressTS.injections = {};
    ExpressTS.functionParams = {};
    ExpressTS.symbols = {
        name: Symbol('injectedName'),
        type: Symbol('type')
    };
    ExpressTS.responders = {};
    ExpressTS.entities = {};
    ExpressTS.domains = {};
    ExpressTS.actions = {};
    return ExpressTS;
}());
exports.default = ExpressTS;
//# sourceMappingURL=ExpressTS.js.map